import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import {
  CreateProfileAbilityEmployee,
  ProfileAbility,
  UpdateProfileAbility,
} from "../entities/ProfileAbility";
import { ProfileAbilityHistory } from "../entities/ProfileAbilityHistory";
import { RequestWithUser } from "../middlewares/user";
import HttpError from "../interfaces/http-error";
import HttpStatus from "../interfaces/http-status";
import HttpSuccess from "../interfaces/http-success";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/ability")
@Tags("ProfileAbilityEmployee")
@Security("bearerAuth")
export class ProfileAbilityEmployeeController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private profileAbilityRepo = AppDataSource.getRepository(ProfileAbility);
  private profileAbilityHistoryRepo = AppDataSource.getRepository(ProfileAbilityHistory);

  @Get("user")
  public async detailProfileAbilityUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const getProfileAbilityId = await this.profileAbilityRepo.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    if (!getProfileAbilityId) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileAbilityId);
  }

  @Get("{profileEmployeeId}")
  public async detailProfileAbility(
    @Path() profileEmployeeId: string,
    @Request() req: RequestWithUser,
  ) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileEmployeeId);
    const getProfileAbilityId = await this.profileAbilityRepo.find({
      where: { profileEmployeeId: profileEmployeeId, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    if (!getProfileAbilityId) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileAbilityId);
  }

  @Get("admin/history/{abilityId}")
  public async getProfileAdminAbilityHistory(
    @Path() abilityId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileAbilityRepo.findOneBy({ id: abilityId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, abilityId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }
    const record = await this.profileAbilityHistoryRepo.find({
      where: { profileAbilityId: abilityId },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Get("history/{abilityId}")
  public async getProfileAbilityHistory(@Path() abilityId: string) {
    const record = await this.profileAbilityHistoryRepo.find({
      where: { profileAbilityId: abilityId },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Post()
  public async newProfileAbility(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileAbilityEmployee,
  ) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }

    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileAbility();
    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileAbilityHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.profileAbilityRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileAbilityId = data.id;
    await this.profileAbilityHistoryRepo.save(history, { data: req });
    //setLogDataDiff(req, { before, after: history });

    return new HttpSuccess(data.id);
  }

  @Patch("{abilityId}")
  public async editProfileAbility(
    @Body() body: UpdateProfileAbility,
    @Request() req: RequestWithUser,
    @Path() abilityId: string,
  ) {
    const record = await this.profileAbilityRepo.findOneBy({ id: abilityId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );
    const before = structuredClone(record);
    // const before_null = null;
    const history = new ProfileAbilityHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileAbilityId = abilityId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    this.profileAbilityRepo.save(record, { data: req });
    setLogDataDiff(req, { before, after: record });
    if (!(Object.keys(body).length === 1 && body.isUpload)) {
      this.profileAbilityHistoryRepo.save(history, { data: req });
      // setLogDataDiff(req, { before, after: history });
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลความสามารถพิเศษ
   * @summary API ลบข้อมูลความสามารถพิเศษ
   * @param abilityId คีย์ความสามารถพิเศษ
   */
  @Patch("update-delete/{abilityId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() abilityId: string,
  ) {
    const record = await this.profileAbilityRepo.findOneBy({ id: abilityId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileAbilityHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileAbilityId = abilityId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.profileAbilityRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.profileAbilityHistoryRepo.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{abilityId}")
  public async deleteProfileAbility(@Path() abilityId: string, @Request() req: RequestWithUser) {
    const _record = await this.profileAbilityRepo.findOneBy({ id: abilityId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }
    await this.profileAbilityHistoryRepo.delete({
      profileAbilityId: abilityId,
    });

    const result = await this.profileAbilityRepo.delete({ id: abilityId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
